#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int maxN = 1 * 100 * 1000;
const int maxM = 1 * 100 * 1000;
const int maxC = 100 * 1000;

int main(int argc, char* argv[]){
	registerValidation(argc, argv);
	int n = inf.readInt(2, maxN, "n");
	inf.readSpace();
	int m = inf.readInt(1, maxM, "m");
	inf.readEoln();

	string g = inf.readLine();
	ensuref(g.size() == n, "Size string is not n");
	for (int j = 0; j < n; j++){
		ensuref(g[j] >= 'a' && g[j] <= 'z', "Illegal character");
	}

	for(int i = 0; i < m; i++){
		char a = inf.readChar();
		inf.readSpace();
		char b = inf.readChar();
		ensuref(b >= 'a' && b <= 'z', "Illegal character to");
		ensuref(a >= 'a' && a <= 'z', "Illegal character from");
		inf.readSpace();
		int len = inf.readInt(0, maxC, "C [0, maxC]");
		inf.readEoln();
	}

	inf.readEof();
}