#include "testlib.h"
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

int main(int argc, char* argv[])
{
	//freopen("output.txt", "wt", stdout);
	int n = atoi(argv[1]);
	
	vector <int> v(n);
	for (int i = 0; i < n; i++)
	{
		v[i] = i;
	}
	shuffle(v.begin(), v.end());
	vector <vector <int> > edges(n);
	for (int i = 0; i < n; i++)
	{
		if (i == 0 || i == n - 1)
		{
			if (!i)
			{
				edges[v[i]].push_back(v[i + 1]);
			}
			else
			{
				edges[v[i]].push_back(v[i - 1]);
			}
		}
		else
		{
			edges[v[i]].push_back(v[i - 1]);
			edges[v[i]].push_back(v[i + 1]);
		}
	}

	printf("%d\n", n);
	for (int i = 0; i < n; i++)
	{
		printf("%d ", edges[i].size());
		for (int j = 0; j < edges[i].size(); j++)
		{
			printf("%d", edges[i][j] + 1);
			if (j < edges[i].size() - 1)
			{
				printf(" ");
			}
		}
		printf("\n");
	}
	return 0;
}