#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int MAXN = (int)1e6;
const int INF = 2 * (int)1e9;

int a[MAXN];
vector <int> d;

int main()
{
	ios::sync_with_stdio(false);
	freopen("secretroom.in", "r", stdin);
	freopen("secretroom.out", "w", stdout);

	int n;
	cin >> n;

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		a[i] += i;		
	}

	d.push_back(-INF);
	
	for (int i = 1; i <= n; i++)
		d.push_back(INF);

	for (int i = 0; i < n; i++)
	{
		int j = int(upper_bound(d.begin(), d.end(), a[i]) - d.begin());	
		if (d[j - 1] < a[i] && a[i] < d[j])
			d[j] = a[i];
	}

	int j = n;
	while (d[j] == INF)
		j--;

	cout << j << endl;  

	return 0;
}