#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <string>
#include <math.h>
using namespace std;

const long long INF = (long long)1e12;

long long d[30][30];

int main()
{
	ios::sync_with_stdio(false);
	freopen("changestr.in", "r", stdin);
	freopen("changestr.out", "w", stdout);

	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;

	for (int i = 0; i < 26; i++)
		for (int j = 0; j < 26; j++)
			d[i][j] = INF;

	for (int i = 0; i < m; i++)
	{
		char a, b;
		long long c;
		cin >> a >> b >> c;

		d[a - 'a'][b - 'a'] = min(d[a - 'a'][b - 'a'], c); 
	}

	for (int i = 0; i < 26; i++)
		d[i][i] = 0;

  for (int k = 0; k < 26; k++)
	  for (int i = 0; i < 26; i++)
		  for (int j = 0; j < 26; j++)
			   d[i][j] = min(d[i][j], d[i][k] + d[k][j]);

         /*
  for (int i = 0; i < 26; i++)
		  for (int j = 0; j < 26; j++)
        if (d[i][j] == 0)
			   cout << i << " " << j << endl;
           */

  long long minsum = INF; 
  for (int k = 1; k < sqrt((double)n) + 1; k++)
	  if (n % k	== 0)
    {
      //cout << k << " ";
      if (k != n)
      {
        long long sum0 = 0;
        for (int i = 0; i < k; i++)
        {
          long long sumi = INF;
          for (int c = 0; c < 26; c++)
          {
            long long sum = 0;
            for (int j = i; j < n; j += k)
              sum += d[s[j] - 'a'][c];
            sumi = min(sumi, sum);
          }
          sum0 += sumi;
        }
        minsum = min(minsum, sum0);
      }

      if (n / k != n)
      {
        long long sum0 = 0;
        for (int i = 0; i < n / k; i++)
        {
          long long sumi = INF;
          for (int c = 0; c < 26; c++)
          {
            long long sum = 0;
            for (int j = i; j < n; j += n / k)
              sum += d[s[j] - 'a'][c];
            sumi = min(sumi, sum);
          }
          sum0 += sumi;
        }
        minsum = min(minsum, sum0);
      }
    }
                          
  if (minsum == INF)
    cout << "-1" << endl;
  else
    cout << minsum << endl;

	return 0;
}